Index: /trunk/src/sh_files.c
===================================================================
--- /trunk/src/sh_files.c	(revision 584)
+++ /trunk/src/sh_files.c	(revision 1)
@@ -1160,277 +726,27 @@
 
   ret = zAVLInsert (zfileList, new_item_ptr);
-  SH_MUTEX_UNLOCK(mutex_zfiles);
 
   if (-1 == ret)
     {
-      (void) safe_logger (0, 0, NULL);
+      (void) safe_logger (0, 0, getpid());
       aud__exit(FIL__, __LINE__, EXIT_FAILURE);
     }
-  else if (3 == ret)
-    { 
-      if (sh.flag.started != S_TRUE)
-	sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_DOUBLE,
-			 fileName);
-      SH_FREE(fileName);
-      SH_FREE(new_item_ptr);
-      new_item_ptr = NULL;
-    }
-  else
-    {
-      int           reported;
-      unsigned long check_flags = sh_files_maskof(class);
-
-      if ((sh.flag.inotify & SH_INOTIFY_INSCAN) != 0)
-	{
-	  sh_files_filecheck (class, check_flags, str_s, NULL,
-			      &reported, 0);
-	  if (SH_FFLAG_REPORTED_SET(reported))
-	    sh_files_set_file_reported(str_s);
-	  sh_inotify_add_watch_later(str_s, &sh_file_watches, NULL,
-				     class, check_flags, 
-				     SH_INOTIFY_FILE, 0);
-	}
-
-      if (MODI_AUDIT_ENABLED(check_flags))
-	{
-	  sh_error_handle(SH_ERR_INFO, FIL__, __LINE__, 0, MSG_E_SUBGPATH,
-			  _("Setting audit watch"),
-			  _("sh_files_push_file_int"), str_s);
-	  sh_audit_mark(str_s);
-	}
-      ++count;
-    }
-  SL_RETURN(count, _("sh_files_push_file_int"));
-}
-
-int sh_files_push_dir_int (int class, char * tail, size_t len, int rdepth, unsigned long check_flags);
-
+  if (3 == ret)
+    sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_DOUBLE,
+		     fileName);
+
+  SL_RETURN(0, _("sh_files_push_file_int"));
+}
+
+
+static int sh_files_pushfile (int class, char * str_s)
+{
+  char  * tmp;
+  int     len;
 #ifdef HAVE_GLOB_H
-
-typedef struct globstack_entry {
-  char                  * name;
-  char                  * type_name;
-  int                     class;
-  unsigned long           check_flags;
-  int                     rdepth;
-  short                   type;
-  /* struct dirstack_entry * next; */
-} sh_globstack_t;
-
-static zAVLTree * zglobList   = NULL;
-
-zAVLKey zglobstack_key (void const * arg)
-{
-  const sh_globstack_t * sa = (const sh_globstack_t *) arg;
-  return (zAVLKey) sa->type_name;
-}
-
-
-static int sh_files_pushglob (int class, int type, const char * p, int rdepth,
-			       unsigned long check_flags_in, int flag)
-{
+  glob_t  pglob;
   int     globstatus = -1;
   unsigned int     gloop;
-  glob_t  pglob;
-
-  volatile int     count = 0;
-  volatile unsigned long check_flags = (flag == 0) ? sh_files_maskof(class) : check_flags_in;
-  
-  SL_ENTER(_("sh_files_pushglob"));
-
-  pglob.gl_offs = 0;
-  globstatus    = glob (p, 0, sh_files_globerr, &pglob);
-  
-  if (sh.flag.checkSum != SH_CHECK_INIT)
-    {
-      sh_globstack_t * new_item_ptr;
-      char  * fileName;
-      char  * typeName;
-      int     ret;
-      
-      SH_MUTEX_TRYLOCK(mutex_zfiles);
-      fileName = sh_util_strdup (p);
-      typeName = sh_util_strconcat ((type == SH_LIST_FILE) ? "F" : "D", p, NULL);
-      
-      new_item_ptr = (sh_globstack_t *) SH_ALLOC (sizeof(sh_globstack_t));
-      
-      new_item_ptr->name           = fileName;
-      new_item_ptr->type_name      = typeName;
-      new_item_ptr->class          = class;
-      new_item_ptr->check_flags    = check_flags;
-      new_item_ptr->rdepth         = rdepth;
-      new_item_ptr->type           = type;
-      
-      if (zglobList == NULL)
-	{
-	  zglobList = zAVLAllocTree (zglobstack_key, zAVL_KEY_STRING);
-	  if (zglobList == NULL) 
-	    {
-	      (void) safe_logger (0, 0, NULL);
-	      aud__exit(FIL__, __LINE__, EXIT_FAILURE);
-	    }
-	}
-      
-      ret = zAVLInsert (zglobList, new_item_ptr);
-      
-      if (ret != 0) /* already in list */
-	{
-	  SH_FREE(fileName);
-	  SH_FREE(typeName);
-	  SH_FREE(new_item_ptr);
-	}
-      SH_MUTEX_TRYLOCK_UNLOCK(mutex_zfiles);
-    }
-
-
-  if (globstatus == 0 && pglob.gl_pathc > 0)
-    {
-      for (gloop = 0; gloop < (unsigned int) pglob.gl_pathc; ++gloop)
-	{
-	  if (type == SH_LIST_FILE)
-	    {
-	      count += sh_files_push_file_int (class, pglob.gl_pathv[gloop], 
-					       sl_strlen(pglob.gl_pathv[gloop]), check_flags);
-	    }
-	  else
-	    {
-	      which_dirList = type;
-
-	      count += sh_files_push_dir_int  (class, pglob.gl_pathv[gloop], 
-					       sl_strlen(pglob.gl_pathv[gloop]), rdepth, check_flags);
-	    }
-	}
-    }
-  else
-    {
-      char * tmp = sh_util_safe_name (p);
-      
-      if (pglob.gl_pathc == 0
-#ifdef GLOB_NOMATCH
-	  || globstatus == GLOB_NOMATCH
-#endif
-	  )
-	sh_error_handle ((sh.flag.started != S_TRUE) ? SH_ERR_ERR : SH_ERR_NOTICE, 
-			 FIL__, __LINE__, 
-			 globstatus, MSG_FI_GLOB,
-			 _("No matches found"), tmp);
-#ifdef GLOB_NOSPACE
-      else if (globstatus == GLOB_NOSPACE)
-	sh_error_handle (SH_ERR_ERR, FIL__, __LINE__,
-			 globstatus, MSG_FI_GLOB,
-			 _("Out of memory"), tmp);
-#endif
-#ifdef GLOB_ABORTED
-      else if (globstatus == GLOB_ABORTED)
-	sh_error_handle (SH_ERR_ERR, FIL__, __LINE__,
-			 globstatus, MSG_FI_GLOB,
-			 _("Read error"), tmp);
-#endif
-      else 
-	sh_error_handle (SH_ERR_ERR, FIL__, __LINE__,
-			 globstatus, MSG_FI_GLOB,
-			 _("Unknown error"), tmp);
-      
-      SH_FREE(tmp);
-      
-    }
-  
-  globfree(&pglob);
-  SL_RETURN(count, _("sh_files_pushglob"));
-  return count;
-}
-
-void sh_files_check_globFilePatterns()
-{
-  sh_globstack_t * testPattern;
-  zAVLCursor   cursor;
-
-  SL_ENTER(_("sh_files_check_globPatterns"));
-
-  SH_MUTEX_LOCK(mutex_zglob);
-  for (testPattern = (sh_globstack_t *) zAVLFirst (&cursor, zglobList); 
-       testPattern;
-       testPattern = (sh_globstack_t *) zAVLNext  (&cursor))
-    {
-      if (testPattern->type == SH_LIST_FILE)
-	{
-	  sh_files_pushglob(testPattern->class, testPattern->type, 
-			    testPattern->name, testPattern->rdepth,
-			    testPattern->check_flags, 1);
-	}
-    }
-  SH_MUTEX_UNLOCK(mutex_zglob);
-  SL_RET0(_("sh_files_check_globPatterns"));
-}
-
-void sh_files_check_globPatterns()
-{
-  sh_globstack_t * testPattern;
-  zAVLCursor   cursor;
-
-  SL_ENTER(_("sh_files_check_globPatterns"));
-
-  SH_MUTEX_LOCK(mutex_zglob);
-  for (testPattern = (sh_globstack_t *) zAVLFirst (&cursor, zglobList); 
-       testPattern;
-       testPattern = (sh_globstack_t *) zAVLNext  (&cursor))
-    {
-      sh_files_pushglob(testPattern->class, testPattern->type, 
-			testPattern->name, testPattern->rdepth,
-			testPattern->check_flags, 1);
-    }
-  SH_MUTEX_UNLOCK(mutex_zglob);
-  SL_RET0(_("sh_files_check_globPatterns"));
-}
-
-/* the destructor
- */
-void free_globstack (void * inptr)
-{
-  sh_globstack_t * here;
-
-  SL_ENTER(_("free_globstack"));
-  if (inptr == NULL)
-    SL_RET0(_("free_globstack"));
-  else
-    here = (sh_globstack_t *) inptr;
-
-  if (here->name != NULL)
-    SH_FREE(here->name);
-  if (here->type_name != NULL)
-    SH_FREE(here->type_name);
-  SH_FREE(here);
-  SL_RET0(_("free_globstack"));
-}
-
-int sh_files_delglobstack ()
-{
-  SL_ENTER(_("sh_files_delglobstack"));
-
-  SH_MUTEX_LOCK(mutex_zglob);
-  zAVLFreeTree (zglobList, free_globstack);
-  zglobList = NULL;
-  SH_MUTEX_UNLOCK(mutex_zglob);
-
-  SL_RETURN(0, _("sh_files_delglobstack"));
-}
-  
-
-#else
-void sh_files_check_globPatterns()
-{
-  return;
-}
-int sh_files_delglobstack ()
-{
-  return 0;
-}
-#endif
-
-static int sh_files_pushfile (int class, const char * str_s)
-{
-  size_t  len;
-  char  * tmp;
-  char  * p;
+#endif
 
   static int reject = 0;
@@ -1444,24 +760,21 @@
    * is the only one -- and will stay the only one
    */
-  if (sh.flag.opts == S_TRUE) 
+  if (sh.flag.opts == 1) 
     {
       sh_files_delfilestack ();
       sh_files_deldirstack ();
-      sh_files_delglobstack ();
       reject = 1;
     }
 
-  p = sh_files_parse_input(str_s, &len);
-  if (!p || len == 0)
-    SL_RETURN((-1), _("sh_files_pushfile"));
-
-  if (sh.flag.checkSum == SH_CHECK_INIT)
-    p = sh_dbIO_rootfs_prepend(p);
-      
+  if (str_s == NULL) 
+    SL_RETURN((-1),_("sh_files_pushfile"));
+
+  len = sl_strlen(str_s);
+
   if (len >= PATH_MAX) 
     {
       /* Name too long
        */
-      tmp = sh_util_safe_name (p);
+      tmp = sh_util_safe_name (str_s);
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_2LONG,
 		       tmp);
@@ -1469,9 +782,15 @@
       SL_RETURN((-1),_("sh_files_pushfile"));
     } 
-  else if (p[0] != '/') 
+  else if (len < 1) 
+    {
+      /* Should not happen (str_s == NULL caught further above)
+       */
+      SL_RETURN((-1),_("sh_files_pushfile"));
+    } 
+  else if (str_s[0] != '/') 
     {
       /* Not an absolute path
        */
-      tmp = sh_util_safe_name (p);
+      tmp = sh_util_safe_name (str_s);
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_NOPATH,
 		       tmp);
@@ -1484,26 +803,68 @@
        * special case of the root directory.
        */
-      if (p[len-1] == '/' && len > 1)
+      if (str_s[len-1] == '/' && len > 1)
 	{
-	  p[len-1] = '\0';
+	  str_s[len-1] = '\0';
 	  --len;
 	}
+      
     } 
 
 #ifdef HAVE_GLOB_H
-  if (0 == sh_files_has_metachar(p))
-    {
-      sh_files_push_file_int (class, p, len, sh_files_maskof(class));
+  if (0 == sh_files_has_metachar(str_s))
+    {
+      sh_files_push_file_int (class, str_s, len);
     }
   else
     {
-      sh_files_pushglob (class, SH_LIST_FILE, p, 0, 0, 0);
+      pglob.gl_offs = 0;
+      globstatus    = glob (str_s, 0, sh_files_globerr, &pglob);
+
+      if (globstatus == 0 && pglob.gl_pathc > 0)
+	{
+	  for (gloop = 0; gloop < (unsigned int) pglob.gl_pathc; ++gloop)
+	    sh_files_push_file_int (class, pglob.gl_pathv[gloop], 
+				    sl_strlen(pglob.gl_pathv[gloop]));
+	}
+      else
+	{
+	  tmp = sh_util_safe_name (str_s);
+
+	  if (pglob.gl_pathc == 0
+#ifdef GLOB_NOMATCH
+	      || globstatus == GLOB_NOMATCH
+#endif
+	      )
+	    sh_error_handle (SH_ERR_ERR, FIL__, __LINE__, 
+			     globstatus, MSG_FI_GLOB,
+			     _("No matches found"), tmp);
+#ifdef GLOB_NOSPACE
+	  else if (globstatus == GLOB_NOSPACE)
+	    sh_error_handle (SH_ERR_ERR, FIL__, __LINE__,
+			     globstatus, MSG_FI_GLOB,
+			     _("Out of memory"), tmp);
+#endif
+#ifdef GLOB_ABORTED
+	  else if (globstatus == GLOB_ABORTED)
+	    sh_error_handle (SH_ERR_ERR, FIL__, __LINE__,
+			     globstatus, MSG_FI_GLOB,
+			     _("Read error"), tmp);
+#endif
+	  else 
+	    sh_error_handle (SH_ERR_ERR, FIL__, __LINE__,
+			     globstatus, MSG_FI_GLOB,
+			     _("Unknown error"), tmp);
+
+	  SH_FREE(tmp);
+
+	}
+
+      globfree(&pglob);
     }
 
 #else
-  sh_files_push_file_int (class, p, len, sh_files_maskof(class));
-#endif
-
-  SH_FREE(p);
+  sh_files_push_file_int (class, str_s, len);
+#endif
+
   SL_RETURN((0),_("sh_files_pushfile"));
 }
@@ -1534,19 +895,10 @@
 int sh_files_is_allignore (char * str)
 {
-  int retval = 0;
-
-  SH_MUTEX_RECURSIVE_INIT(mutex_zdirs);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_zdirs);
-  retval = sh_files_is_allignore_int(str, zdirListOne);
-
-  if (NULL != zdirListTwo && retval == 0)
-    {
-      retval = sh_files_is_allignore_int(str, zdirListTwo);
-    }
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_zdirs);
-  return retval;
-}
-
-void * sh_dummy_1493_ptr;
+  if (1 == sh_files_is_allignore_int(str, zdirListOne))
+    return 1;
+  if (NULL == zdirListTwo)
+    return 0;
+  return sh_files_is_allignore_int(str, zdirListTwo);
+}
 
 unsigned long sh_dirs_chk (int which)
@@ -1557,15 +909,9 @@
   dirstack_t * dst_ptr;
   int          status;
-  int          tmp_reported;
-  volatile int          filetype = SH_FILE_UNKNOWN;
-  volatile unsigned long dcount = 0;
+  unsigned long dcount = 0;
   char       * tmp;
   
   SL_ENTER(_("sh_dirs_chk"));
 
-  sh_dummy_1493_ptr = (void *) &ptr;
-  
-  SH_MUTEX_RECURSIVE_INIT(mutex_zdirs);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_zdirs);
   if (which == 1)
     tree = zdirListOne;
@@ -1577,10 +923,9 @@
     {
       if (sig_urgent > 0) {
-	goto out;
+	SL_RETURN(dcount, _("sh_dirs_chk"));
       }
 
       if (ptr->checked == S_FALSE)
 	{
-	  SH_MUTEX_LOCK(mutex_zfiles);
 	  /* 28 Aug 2001 check the top level directory
 	   */
@@ -1592,36 +937,25 @@
 		{
 		  BREAKEXIT(sh_files_filecheck);
-		  tmp_reported = dst_ptr->is_reported;
-		  filetype = sh_files_filecheck (dst_ptr->class, dst_ptr->check_flags, 
-						 ptr->name,  
-						 NULL,  &tmp_reported, 0);
-		  dst_ptr->is_reported = tmp_reported;
-		  (void) handle_filecheck_ret(dst_ptr, NULL, filetype);
-
+		  sh_files_filecheck (dst_ptr->class,  ptr->name,  
+				      NULL,  &status, 0);
 		  dst_ptr->checked = S_TRUE;
 		  status           = S_TRUE;
+		  break;
 		}
 	      else
 		{
 		  status           = S_TRUE;
+		  break;
 		}
 	    }
-	  SH_MUTEX_UNLOCK(mutex_zfiles);
 
 	  if (status == S_FALSE)
-	    {
-	      tmp_reported = ptr->is_reported;
-	      filetype = sh_files_filecheck (ptr->class,  ptr->check_flags, 
-					     ptr->name,  NULL,  &tmp_reported, 0);
-	      ptr->is_reported = tmp_reported;
-	      (void) handle_filecheck_ret(ptr, NULL, filetype);
-	    }
+	    sh_files_filecheck (ptr->class,  ptr->name,  NULL,  &status, 0);
 
 	  BREAKEXIT(sh_files_checkdir);
-	  status = sh_files_checkdir (ptr->class, ptr->check_flags, 
-				      ptr->rdepth, ptr->name, 
+	  status = sh_files_checkdir (ptr->class, ptr->rdepth, ptr->name, 
 				      ptr->name);
 
-	  if (status < 0 && (!SH_FFLAG_REPORTED_SET(ptr->is_reported))) 
+	  if (status < 0 && ptr->reported == S_FALSE) 
 	    {
 	      /* directory is missing
@@ -1634,15 +968,13 @@
 					      ShDFLevel[SH_ERR_T_DIR])) {
 		    tmp = sh_util_safe_name (ptr->name);
-		    if (!sh_global_check_silent)
-		      sh_error_handle ((ptr->class == SH_LEVEL_ALLIGNORE) ? 
-				       ShDFLevel[ptr->class] : 
-				       ShDFLevel[SH_ERR_T_DIR], FIL__, __LINE__,
-				       0, MSG_FI_MISS, tmp);
-		    ++sh.statistics.files_report;
+		    sh_error_handle ((ptr->class == SH_LEVEL_ALLIGNORE) ? 
+				     ShDFLevel[ptr->class] : 
+				     ShDFLevel[SH_ERR_T_DIR], FIL__, __LINE__,
+				     0, MSG_FI_MISS, tmp);
 		    SH_FREE(tmp);
 		  }
 		}
 	      if (sh.flag.reportonce == S_TRUE)
-		SET_SH_FFLAG_REPORTED(ptr->is_reported);
+		ptr->reported = S_TRUE;
 	    } 
 	  else 
@@ -1650,8 +982,7 @@
 	      /* exists (status >= 0), but was missing (reported == TRUE)
 	       */
-	      if (status >= 0 && SH_FFLAG_REPORTED_SET(ptr->is_reported))
+	      if (status >= 0 && ptr->reported == S_TRUE)
 		{
-		  CLEAR_SH_FFLAG_REPORTED(ptr->is_reported);
-		  sh_hash_clear_flag(ptr->name, SH_FFLAG_ENOENT);
+		  ptr->reported = S_FALSE;
 #if 0
 		  /* obsoleted (really?) by the mandatory sh_files_filecheck()
@@ -1659,11 +990,9 @@
 		   */
 		  tmp = sh_util_safe_name (ptr->name);
-		  if (!sh_global_check_silent)
-		    sh_error_handle ((ptr->class == SH_LEVEL_ALLIGNORE) ? 
-				     ShDFLevel[ptr->class] : 
-				     ShDFLevel[SH_ERR_T_DIR],
-				     FIL__, __LINE__, 0, MSG_FI_ADD,
-				     tmp);
-		  ++sh.statistics.files_report;
+		  sh_error_handle ((ptr->class == SH_LEVEL_ALLIGNORE) ? 
+				   ShDFLevel[ptr->class] : 
+				   ShDFLevel[SH_ERR_T_DIR],
+				   FIL__, __LINE__, 0, MSG_FI_ADD,
+				   tmp);
 		  SH_FREE(tmp);
 #endif
@@ -1684,90 +1013,72 @@
 	      ++dcount;
 	    }
-	  ptr->checked        = S_TRUE;
-	  ptr->childs_checked = S_TRUE;
+	  ptr->checked = S_TRUE;
 	}
 
       if (sig_urgent > 0) {
-	goto out;
+	SL_RETURN(dcount, _("sh_dirs_chk"));
       }
 
     }
- out:
-  ; /* 'label at end of compound statement' */
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_zdirs);
-
   SL_RETURN(dcount, _("sh_dirs_chk"));
 }
 
-int sh_files_pushdir_prelink (const char * str_s)
+int sh_files_pushdir_prelink (char * str_s)
 {
   return (sh_files_pushdir (SH_LEVEL_PRELINK, str_s));
 }
 
-int sh_files_pushdir_user0 (const char * str_s)
+int sh_files_pushdir_user0 (char * str_s)
 {
   return (sh_files_pushdir (SH_LEVEL_USER0, str_s));
 }
 
-int sh_files_pushdir_user1 (const char * str_s)
+int sh_files_pushdir_user1 (char * str_s)
 {
   return (sh_files_pushdir (SH_LEVEL_USER1, str_s));
 }
 
-int sh_files_pushdir_user2 (const char * str_s)
-{
-  return (sh_files_pushdir (SH_LEVEL_USER2, str_s));
-}
-
-int sh_files_pushdir_user3 (const char * str_s)
-{
-  return (sh_files_pushdir (SH_LEVEL_USER3, str_s));
-}
-
-int sh_files_pushdir_user4 (const char * str_s)
-{
-  return (sh_files_pushdir (SH_LEVEL_USER4, str_s));
-}
-
-int sh_files_pushdir_attr (const char * str_s)
+int sh_files_pushdir_attr (char * str_s)
 {
   return (sh_files_pushdir (SH_LEVEL_ATTRIBUTES, str_s));
 }
 
-int sh_files_pushdir_ro (const char * str_s)
+int sh_files_pushdir_ro (char * str_s)
 {
   return (sh_files_pushdir (SH_LEVEL_READONLY, str_s));
 }
 
-int sh_files_pushdir_log (const char * str_s)
+int sh_files_pushdir_log (char * str_s)
 {
   return (sh_files_pushdir (SH_LEVEL_LOGFILES, str_s));
 }
 
-int sh_files_pushdir_glog (const char * str_s)
+int sh_files_pushdir_glog (char * str_s)
 {
   return (sh_files_pushdir (SH_LEVEL_LOGGROW, str_s));
 }
 
-int sh_files_pushdir_noig (const char * str_s)
+int sh_files_pushdir_noig (char * str_s)
 {
   return (sh_files_pushdir (SH_LEVEL_NOIGNORE, str_s));
 }
 
-int sh_files_pushdir_allig (const char * str_s)
+int sh_files_pushdir_allig (char * str_s)
 {
   return (sh_files_pushdir (SH_LEVEL_ALLIGNORE, str_s));
 }
 
+static int which_dirList = 1;
+
 int set_dirList (int which)
 {
   if (which == 2)
-    which_dirList = SH_LIST_DIR2;
+    which_dirList = 2;
   else
-    which_dirList = SH_LIST_DIR1;
+    which_dirList = 1;
   return 0;
 }
 
-int sh_files_push_dir_int (int class, char * tail, size_t len, int rdepth, unsigned long check_flags)
+int sh_files_push_dir_int (int class, char * tail, int len, int rdepth)
 {
   zAVLTree   * tree;
@@ -1785,13 +1096,11 @@
   new_item_ptr->name           = dirName;
   new_item_ptr->class          = class;
-  new_item_ptr->check_flags     = check_flags;
+  new_item_ptr->check_mask     = sh_files_maskof(class);
   new_item_ptr->rdepth         = rdepth;
   new_item_ptr->checked        = S_FALSE;
-  new_item_ptr->is_reported    = 0;
+  new_item_ptr->reported       = S_FALSE;
   new_item_ptr->childs_checked = S_FALSE;
 
-  SH_MUTEX_RECURSIVE_INIT(mutex_zdirs);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_zdirs);
-  if (which_dirList == SH_LIST_DIR1)
+  if (which_dirList == 1)
     {
       tree = zdirListOne;
@@ -1804,11 +1113,11 @@
   if (tree == NULL)
     {
-      tree = zAVLAllocTree (zdirstack_key, zAVL_KEY_STRING);
+      tree = zAVLAllocTree (zdirstack_key);
       if (tree == NULL) 
 	{
-	  (void) safe_logger (0, 0, NULL);
+	  (void) safe_logger (0, 0, getpid());
 	  aud__exit(FIL__, __LINE__, EXIT_FAILURE);
 	}
-      if (which_dirList == SH_LIST_DIR1)
+      if (which_dirList == 1)
 	zdirListOne = tree;
       else
@@ -1817,82 +1126,53 @@
 
   ret = zAVLInsert (tree, new_item_ptr);
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_zdirs);
 
   if (-1 == ret)
     {
-      (void) safe_logger (0, 0, NULL);
+      (void) safe_logger (0, 0, getpid());
       aud__exit(FIL__, __LINE__, EXIT_FAILURE);
     }
   if (3 == ret)
-    { 
-      if (sh.flag.started != S_TRUE)
-	sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_DOUBLE,
-			 dirName);
-      SH_FREE(dirName);
-      SH_FREE(new_item_ptr);
-      new_item_ptr = NULL;
-    }
-  else
-    {
-      if (MODI_AUDIT_ENABLED(check_flags))
-	{
-	  sh_error_handle(SH_ERR_INFO, FIL__, __LINE__, 0, MSG_E_SUBGPATH,
-			  _("Setting audit watch"),
-			  _("sh_files_push_file_int"), tail);
-	  sh_audit_mark(tail);
-	}
-    }
+    sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_DOUBLE,
+		     dirName);
+
   SL_RETURN(0, _("sh_files_push_dir_int"));
 }
 
-static int sh_files_pushdir (int class, const char * str_s)
+static int sh_files_pushdir (int class, char * str_s)
 {
   char  * tmp;
-  size_t  len;
+  int     len;
   int     rdepth = 0;
   char  * tail = NULL;
-  char  * p;
+
+#ifdef HAVE_GLOB_H
+  glob_t  pglob;
+  int     globstatus = -1;
+  unsigned int     gloop;
+#endif
 
   SL_ENTER(_("sh_files_pushdir"));
 
-  if (sh.flag.opts == S_TRUE) {
+  if (sh.flag.opts == 1) {
     sh_files_delfilestack ();
     sh_files_deldirstack ();
-    sh_files_delglobstack ();
   }
 
-  p = sh_files_parse_input(str_s, &len);
-  if (!p || len == 0)
-    SL_RETURN((-1),_("sh_files_pushdir"));
-
-  if (p[0] != '/')
-    {
-      rdepth = strtol(p, &tail, 10);
-      if (tail == p)
-	{
-	  SH_FREE(p);
-	  SL_RETURN((-1), _("sh_files_pushdir"));
-	}
+  if (str_s == NULL)
+    SL_RETURN((-1), _("sh_files_pushdir"));
+  
+
+  if (str_s[0] != '/')
+    {
+      rdepth = strtol(str_s, &tail, 10);
+      if (tail == str_s)
+	SL_RETURN((-1), _("sh_files_pushdir"));
     }
   else
-    tail   = p;
+    tail   = str_s;
   
 
-  if (tail == p)
-    {
-      /* Setting to an invalid number will force MaxRecursionLevel,
-       * see sh_files_setrec_int()
-       */
-      rdepth = (-2);
-    }
-  else if ( (rdepth < (-1) || rdepth > 99) || 
-	    ((rdepth == (-1)) && (class != SH_LEVEL_ALLIGNORE)) )
-    {
-      SH_FREE(p);
-      SL_RETURN((-1), _("sh_files_pushdir"));
-    }
-
-  if (sh.flag.checkSum == SH_CHECK_INIT)
-    tail = sh_dbIO_rootfs_prepend(tail);
+  if (rdepth < (-1) || tail == str_s || rdepth > 99)
+    rdepth = (-2);
 
   len = sl_strlen(tail);
@@ -1904,10 +1184,8 @@
 		       tmp);
       SH_FREE(tmp);
-      SH_FREE(p);
       SL_RETURN((-1), _("sh_files_pushdir"));
     } 
   else if (len < 1) 
     {
-      SH_FREE(p);
       SL_RETURN((-1), _("sh_files_pushdir"));
     } 
@@ -1918,9 +1196,9 @@
 		       tmp);
       SH_FREE(tmp);
-      SH_FREE(p);
       SL_RETURN((-1), _("sh_files_pushdir"));
     } 
   else 
     {
+      
       if (tail[len-1] == '/' && len > 1)
 	{
@@ -1928,4 +1206,5 @@
 	  --len;
 	}
+      
     } 
 
@@ -1933,26 +1212,66 @@
   if (0 == sh_files_has_metachar(tail))
     {
-      sh_files_push_dir_int (class, tail, len, rdepth, sh_files_maskof(class));
+      sh_files_push_dir_int (class, tail, len, rdepth);
     }
   else
     {
-      sh_files_pushglob (class, which_dirList, tail, rdepth, 0, 0);
+      pglob.gl_offs = 0;
+      globstatus    = glob (tail, 0, sh_files_globerr, &pglob);
+
+      if (globstatus == 0 && pglob.gl_pathc > 0)
+	{
+	  for (gloop = 0; gloop < (unsigned int) pglob.gl_pathc; ++gloop)
+	    sh_files_push_dir_int (class, 
+				   pglob.gl_pathv[gloop], 
+				   sl_strlen(pglob.gl_pathv[gloop]), 
+				   rdepth);
+	}
+      else
+	{
+	  tmp = sh_util_safe_name (tail);
+
+	  if (pglob.gl_pathc == 0
+#ifdef GLOB_NOMATCH
+	      || globstatus == GLOB_NOMATCH
+#endif
+	      )
+	    sh_error_handle (SH_ERR_ERR, FIL__, __LINE__, 
+			     globstatus, MSG_FI_GLOB,
+			     _("No matches found"), tmp);
+#ifdef GLOB_NOSPACE
+	  else if (globstatus == GLOB_NOSPACE)
+	    sh_error_handle (SH_ERR_ERR, FIL__, __LINE__,
+			     globstatus, MSG_FI_GLOB,
+			     _("Out of memory"), tmp);
+#endif
+#ifdef GLOB_ABORTED
+	  else if (globstatus == GLOB_ABORTED)
+	    sh_error_handle (SH_ERR_ERR, FIL__, __LINE__,
+			     globstatus, MSG_FI_GLOB,
+			     _("Read error"), tmp);
+#endif
+	  else 
+	    sh_error_handle (SH_ERR_ERR, FIL__, __LINE__,
+			     globstatus, MSG_FI_GLOB,
+			     _("Unknown error"), tmp);
+	  SH_FREE(tmp);
+	}
+
+      globfree(&pglob);
     }
 #else  
-  sh_files_push_dir_int (class, tail, len, rdepth, sh_files_maskof(class));
-#endif
-
-  SH_FREE(p);
+  sh_files_push_dir_int (class, tail, len, rdepth);
+#endif
+
   SL_RETURN((0), _("sh_files_pushdir"));
-}
-
-/**
+}  
+
 struct sh_dirent {
+  /* char               sh_d_name[NAME_MAX + 2]; */
   char             * sh_d_name;
   struct sh_dirent * next;
 };
-**/
-
-void kill_sh_dirlist (struct sh_dirent * dirlist)
+
+static void kill_sh_dirlist (struct sh_dirent * dirlist)
 {
   struct sh_dirent * this;
@@ -1970,17 +1289,17 @@
 /* -- add an entry to a directory listing
  */
-struct sh_dirent * addto_sh_dirlist (struct dirent * thisEntry, 
-				     struct sh_dirent * dirlist)
+static struct sh_dirent * addto_sh_dirlist (struct dirent * thisEntry, 
+					    struct sh_dirent * dirlist)
 {
   struct sh_dirent * this;
-  size_t len;
+  int i;
 
   if (thisEntry == NULL)
     return dirlist;
   
-  len = sl_strlen(thisEntry->d_name);
-  if (len == 0)
+  i = sl_strlen(thisEntry->d_name);
+  if (i == 0)
     return dirlist;
-  ++len;
+  ++i;
   
   this = SH_ALLOC(sizeof(struct sh_dirent));
@@ -1988,6 +1307,6 @@
     return dirlist;
 
-  this->sh_d_name = SH_ALLOC(len);
-  sl_strlcpy(this->sh_d_name, thisEntry->d_name, len);
+  this->sh_d_name = SH_ALLOC(i);
+  sl_strlcpy(this->sh_d_name, thisEntry->d_name, i);
 
   this->next = dirlist;
@@ -1999,5 +1318,5 @@
 /* Simply sets our boolean as to whether this check is active 
  */
-int sh_files_check_hardlinks (const char * opt)
+int sh_files_check_hardlinks (char * opt)
 {
   int i;
@@ -2015,5 +1334,5 @@
 static struct sh_hle_struct * sh_hl_exc = NULL;
 
-int sh_files_hle_reg (const char * str)
+int sh_files_hle_reg (char * str)
 {
   long   offset;
@@ -2075,72 +1394,41 @@
       tmp = tmp->next;
     }
-#ifdef HAVE_FNMATCH_H
-  if ( (offset == 1) && (0 == fnmatch(_("/run/user/*"), path, FNM_PATHNAME)) )
-    {
-      /* gvfs directory in /run/user/username/ */
-      SL_RETURN(0, _("sh_files_hle_test"));
-    }
-#endif
-
   SL_RETURN(-1, _("sh_files_hle_test"));
 }
 #endif
 
-/* This is the LCG from Numerical Recipies. Deterministic. 
+/* -- check a single directory and its content
  */
-static unsigned int simple_rand(unsigned int * state)
-{
-  *state = 1664525 * (*state) + 1013904223;
-  return *state;
-}
-
-void * sh_dummy_dirlist;
-void * sh_dummy_tmpcat;
-
-/* -- Check a single directory and its content. Does not
- *    check the directory inode itself.
- */
-int sh_files_checkdir (int iclass, unsigned long check_flags, 
-		       int idepth, char * iname, 
-		       char * relativeName)
-{
-  struct sh_dirent * dirlist;
-  struct sh_dirent * dirlist_orig;
+static int sh_files_checkdir (int iclass, int idepth, char * iname, 
+			      char * relativeName)
+{
+  struct sh_dirent * dirlist = NULL;
+  struct sh_dirent * dirlist_orig = NULL;
 
   DIR *           thisDir = NULL;
   struct dirent * thisEntry;
-#if defined(SH_USE_SCANDIR)
-  struct dirent **entryList;
-  int             entry;
-#endif
   int             status;
   int             dummy = S_FALSE;
-  dir_type      * theDir;
+  dir_type        theDir;
   ShFileType      checkit;
-  static unsigned int state = 1;
-
-  file_type     * theFile;
+
+
+  file_type       theFile;
   char          * tmpname;
   char          * tmpcat;
-  char errbuf[SH_ERRBUF_SIZE];
 
   int             rdepth = 0;
   int             class  = 0;
-  volatile int    rdepth_next;
-  volatile int    class_next;
-  volatile int    file_class_next;
-  volatile unsigned long   check_flags_next;
-  volatile unsigned long   file_check_flags_next;
-
-  volatile int    checked_flag  = S_FALSE;
-  volatile int    cchecked_flag = S_FALSE;
+  int             rdepth_next;
+  int             class_next;
+  int             file_class_next;
+
+  int             checked_flag  = S_FALSE;
+  int             cchecked_flag = S_FALSE;
 
   dirstack_t *    dst_ptr;
-  dirstack_t *    tmp_ptr;
 
   int             hardlink_num = 0;
-#if !defined(HOST_IS_DARWIN)
-  size_t          len;
-#endif
+
 
   SL_ENTER(_("sh_files_checkdir"));
@@ -2171,12 +1459,7 @@
     }
 
-  if (flag_err_info == S_TRUE)
-    {
-      char pstr[32];
-
-      sl_strlcpy(pstr, sh_hash_getpolicy(iclass), sizeof(pstr));
-      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_CHK, pstr, tmpname);
-    }
-
+  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_CHK,
+		   tmpname);
+  
   /* ---- check input ----
    */
@@ -2199,24 +1482,17 @@
       SL_RETURN((-1), _("sh_files_checkdir"));
     }
-
+    
+    
   /* ---- stat the directory ----
    */
-  theFile = SH_ALLOC(sizeof(file_type));
-  sl_strlcpy (theFile->fullpath, iname, PATH_MAX);
-  theFile->attr_string = NULL;
-  theFile->link_path   = NULL;
-  theFile->check_flags  = check_flags;
+  sl_strlcpy (theFile.fullpath, iname, PATH_MAX);
 
   (void) relativeName;
   status = sh_unix_getinfo (ShDFLevel[SH_ERR_T_DIR], 
 			    iname,
-			    theFile, NULL, iclass);
+			    &theFile, NULL, iclass);
 
   if ((sig_termfast == 1) || (sig_terminate == 1)) 
     {
-      if (theFile->attr_string) SH_FREE(theFile->attr_string);
-      if (theFile->link_path)   SH_FREE(theFile->link_path);
-      SH_FREE(theFile);
-      SH_FREE(tmpname);
       SL_RETURN((0), _("sh_files_checkdir"));
     }
@@ -2224,36 +1500,19 @@
   if (status == -1)
     {
-      if (theFile->attr_string) SH_FREE(theFile->attr_string);
-      if (theFile->link_path)   SH_FREE(theFile->link_path);
-      SH_FREE(theFile);
-      SH_FREE(tmpname);
+      SH_FREE(tmpname); 
       SL_RETURN((-1), _("sh_files_checkdir"));
     }
 
-  if (theFile->c_mode[0] != 'd') 
+  if (theFile.c_mode[0] != 'd') 
     { 
-      if (!sh_global_check_silent)
-	sh_error_handle (ShDFLevel[SH_ERR_T_DIR], FIL__, __LINE__, 0,
-			 MSG_FI_NODIR,
-			 tmpname);
-      ++sh.statistics.files_nodir;
-      if (theFile->attr_string) SH_FREE(theFile->attr_string);
-      if (theFile->link_path)   SH_FREE(theFile->link_path);
-      SH_FREE(theFile);
-      SH_FREE(tmpname);
+      sh_error_handle (ShDFLevel[SH_ERR_T_DIR], FIL__, __LINE__, 0,
+		       MSG_FI_NODIR,
+		       tmpname);
+      SH_FREE(tmpname); 
       SL_RETURN((-1), _("sh_files_checkdir"));
     }
 
-  if ((sh.flag.inotify & SH_INOTIFY_INSCAN) != 0)
-    {
-      sh_inotify_add_watch_later(iname, &sh_file_watches, &status,
-				 iclass, check_flags, SH_INOTIFY_DIR, idepth);
-    }
-   
-  hardlink_num = theFile->hardlinks;
-
-  if (theFile->attr_string) SH_FREE(theFile->attr_string);
-  if (theFile->link_path)   SH_FREE(theFile->link_path);
-  SH_FREE(theFile);
+  hardlink_num = theFile.hardlinks;
+
 
   /* ---- open directory for reading ---- 
